<template>
    <div class="card bg-neutral w-full shadow-xl mx-auto mb-4">
        <div class="card-body">
            <div class="flex flex-nowrap align-center items-center justify-between mb-4">
                <div class="flex flex-nowrap justify-normal align-center items-center">
                    <div v-if="itemIcon" class="avatar bg-primary rounded-full p-4">
                        <img :src="getIcon(itemIcon)" class="w-full" style="filter: invert(1) grayscale(100%);" />
                        <!-- <span class="material-symbols-outlined text-center">{{ itemIcon }}</span> -->
                    </div>
                    <div>
                        <div class="mx-4">
                            <h2 class="card-title whitespace-normal overflow-wrap break-word" v-html="itemName"></h2>
                            <div v-if="itemDevice">
                                related to <span @click="$router.push('/devices')" class="font-bold btn-link break-word" v-html="itemDevice"></span> 
                            </div>
                        </div>
                        <div v-if="itemRoom" class="badge my-4 badge-outline mx-4" v-html="itemRoomName"></div>
                    </div>
                </div>
                <div>
                    <div class="flex flex-nowrap align-center items-center justify-between space-x-2">
                        <input v-if="itemType !== 'condition'" type="checkbox" class="toggle toggle-lg toggle-primary" v-model="status" @change="toggleStatus" />&nbsp;

                        <div class="dropdown dropdown-bottom dropdown-end">
                            <div tabindex="0" role="button" class="btn m-1">
                                <span class="material-symbols-outlined">more_horiz</span>
                            </div>
                            <ul tabindex="0" class="dropdown-content z-[1] menu p-2 shadow bg-base-100 rounded-box w-52">
                                <li><a @click="handleEdit"><span class="material-symbols-outlined" >edit</span> Edit</a></li>
                                <li><a @click="handleDelete"><span class="material-symbols-outlined">delete</span> Delete</a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
            <div v-if="itemDescription" class="bg-base-200 rounded p-5">
                <div class="flex align-center items-center justify-between" v-html="showDescription ? '<span>Hide Description</span><span class=\'material-symbols-outlined text-center\'>expand_less</span>' : '<span>Show Description</span><span class=\'material-symbols-outlined text-center\'>expand_more</span>'" @click="toggleDescription"></div>
                <div v-if="showDescription" class="pt-5"> 
                    <p v-html="itemDescription"></p>
                </div>
            </div>

            <div v-if="itemCurrConsumption != '' && itemWeekConsumption != ''" class="bg-base-200 rounded p-5">
                <div class="flex align-center items-center justify-between" v-html="showConsumptions ? '<span>Hide Consumption Stats</span><span class=\'material-symbols-outlined text-center\'>expand_less</span>' : '<span>Show Consumption Stats</span><span class=\'material-symbols-outlined text-center\'>expand_more</span>'" @click="toggleConsumptions"></div>
                <div v-if="showConsumptions" class="rounded p-5 stats shadow w-full mt-5">
                    <div class="stat place-items-center">
                        <div class="stat-title">Current Consumption</div>
                        <div class="stat-value" :style="{ color: (ratio > 0 ? 'red' : 'green') }">{{ itemCurrConsumption }}</div>
                        <div class="stat-desc" :style="{ color: (ratio > 0 ? 'red' : 'green') }">
                            <span v-if="ratio < 0">↘︎</span>
                            <span v-if="ratio > 0">↗︎</span>
                            <span v-if="ratio == 0">=</span>
                            {{abs(ratio)}}% 
                        </div>
                    </div>
                    <div class="stat place-items-center">
                        <div class="stat-title">Weekly Consumption</div>
                        <div class="stat-value">{{ itemWeekConsumption }}</div>
                        <div class="stat-desc"></div>
                    </div>
                </div>
            </div>

            <div v-if="itemActorType" class="mt-6 border-t bg-base-100 rounded-md">
                <dl class="divide-y">
                    <div class="px-4 py-6 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-0" v-if="itemActorType">
                        <dt class="text-sm font-medium leading-6 text-white-500">Condition Type</dt>
                        <dd class="mt-1 text-sm leading-6 text-white-100 sm:col-span-2 sm:mt-0" v-html="itemActorType"></dd>
                    </div>
                    <div class="px-4 py-6 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-0" v-if="itemActorId">
                        <dt class="text-sm font-medium leading-6 text-white-500">Actor Id</dt>
                        <dd class="mt-1 text-sm leading-6 text-white-100 sm:col-span-2 sm:mt-0" v-html="itemActorName"></dd>
                    </div>
                    <div class="px-4 py-6 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-0" v-if="itemOperator">
                        <dt class="text-sm font-medium leading-6 text-white-500">Logic operator to satisfy the condition with following values:</dt>
                        <dd class="mt-1 text-sm leading-6 text-white-100 sm:col-span-2 sm:mt-0" v-html="itemOperator"></dd>
                    </div>
                    <div class="px-4 py-6 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-0" v-if="itemValue1">
                        <dt class="text-sm font-medium leading-6 text-white-500">First value</dt>
                        <dd class="mt-1 text-sm leading-6 text-white-100 sm:col-span-2 sm:mt-0" v-html="itemValue1"></dd>
                    </div>
                    <div class="px-4 py-6 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-0" v-if="itemValue2">
                        <dt class="text-sm font-medium leading-6 text-white-500">Second value</dt>
                        <dd class="mt-1 text-sm leading-6 text-white-100 sm:col-span-2 sm:mt-0" v-html="itemValue2"></dd>
                    </div>
                </dl>
            </div>

            <div v-if="itemType === 'routine'" class="mt-4 text-center">
                <button class="btn btn-accent" @click="handleClick">Go to Activities</button>
            </div>
            <div v-if="itemType === 'activity'" class="mt-4 text-center">
                <button class="btn btn-accent" @click="handleClick">Go to Conditions</button>
            </div>
        </div>
    </div>
</template>

<script>
import ICONS from '@/assets/icons.json';
export default {
    data() {
        return {
            showDescription: false,
            showConsumptions: false,
            status: false
        }
    },
    async mounted() {
        this.status = this.itemStatus === 'active';
        if(this.itemCurrConsumption != "" || this.itemWeekConsumption != "")
            this.ratio = parseFloat(this.calculateRatio(this.itemCurrConsumption, this.itemWeekConsumption));
        this.ratio == 0
    },
    props: {
        itemId: {
            type: String,
            required: true,
            default: ''
        },
        itemIcon: {
            type: String,
            required: false,
            default: ''
        },
        itemName: {
            type: String,
            required: true,
        },
        itemDescription: {
            type: String,
            required: false,
            default: ''
        },
        itemType: {
            type: String,
            required: true,
            default: ''
        },
        itemStatus: {
            type: String,
            required: false,
            default: "active"
        },
        itemRoom: {
            type: String,
            required: false,
            default: ''
        },
        itemRoomName: {
            type: String,
            required: false,
            default: ''
        },
        itemCurrConsumption: {
            type: String,
            required: false,
            default: ""
        },
        itemWeekConsumption: {
            type: String,
            required: false,
            default: ""
        },
        itemActorType: {
            type: String,
            required: false,
            default: ""
        },
        itemActorName: {
            type: String,
            required: false,
            default: ""
        },
        itemActorId: {
            type: String,
            required: false,
            default: ""
        },
        itemOperator: {
            type: String,
            required: false,
            default: ""
        },
        itemValue1: {
            type: String,
            required: false,
            default: ""
        },
        itemValue2: {
            type: String,
            required: false,
            default: ""
        },
        itemDevice: {
            type: String,
            required: false,
            default: ""
        }
    },
    methods: {
        handleClick() {
            // Emit a custom event to notify the parent component about the click
            this.$emit('clickEvent', {
                itemId: this.itemId,
                itemIcon: this.itemIcon,
                itemName: this.itemName,
                itemDescription: this.itemDescription,
                itemStatus: this.itemStatus ? 'active' : 'inactive',
                itemType: this.itemType,
                itemRoom: this.itemRoom
            });
        },
        handleEdit() {
            this.$emit('editEvent', {
                itemId: this.itemId,
                itemIcon: this.itemIcon,
                itemName: this.itemName,
                itemDescription: this.itemDescription,
                itemStatus: this.itemStatus ? 'active' : 'inactive',
                itemType: this.itemType,
                itemRoom: this.itemRoom,
                itemActorType: this.itemActorType,
                itemActorName: this.itemActorName,
                itemActorId: this.itemActorId,
                itemOperator: this.itemOperator,
                itemValue1: this.itemValue1,
                itemValue2: this.itemValue2,
            });
        },
        handleDelete() {
            // Emit a custom event to notify the parent component about the click
            this.$emit('deleteEvent', {
                itemId: this.itemId,
                itemIcon: this.itemIcon,
                itemName: this.itemName,
                itemDescription: this.itemDescription,
                itemStatus: this.itemStatus ? 'active' : 'inactive',
                itemType: this.itemType,
                itemRoom: this.itemRoom,
                itemActorType: this.itemActorType,
                itemActorName: this.itemActorName,
                itemActorId: this.itemActorId,
                itemOperator: this.itemOperator,
                itemValue1: this.itemValue1,
                itemValue2: this.itemValue2
            });
        },
        toggleStatus() {
            // Emit a custom event to notify the parent component about the click
            //this.status = status.target.checked;
            let newStatus = this.status ? 'active' : 'inactive';
            this.$emit('updateStatus', {
                id: this.itemId,
                status: newStatus,
            });
        },
        toggleDescription() { this.showDescription = !this.showDescription; },
        toggleConsumptions() { this.showConsumptions = !this.showConsumptions; },
        getIcon(iconSlug) {
            return ICONS.find(item => item.slug === iconSlug).iconUrl
        },
        calculateRatio(currentConsumption, weeklyConsumption){
            const regex = /[0-9]+(?:[.,][0-9]+)*/g;
            const current = currentConsumption.match(regex)[0];
            const weekly = weeklyConsumption.match(regex)[0];

            if(current != 0 && weekly != 0)
                return ((current - weekly) / weekly).toFixed(2);
            return 0;
        },
        abs(value) {
            if(value < 0) return -1 * value;
            return value;
        }
    },
    computed: {
        glueConsumptions() {
            return `${this.itemCurrConsumption}|${this.itemWeekConsumption}`;
        },
        getStatus() {
            return this.itemStatus;
        }
    },
    watch: {
        glueConsumptions(newVal, oldVal) {
            const [oldItemCurrConsumption, oldItemWeekConsumption] = oldVal.split('|');
            const [newItemCurrConsumption, newItemWeekConsumption] = newVal.split('|');
            if (oldItemCurrConsumption !== newItemCurrConsumption || oldItemWeekConsumption !== newItemWeekConsumption) {
                this.ratio = this.calculateRatio(newItemCurrConsumption, newItemWeekConsumption);
            }  
        },
        getStatus(newVal, oldVal) {
            if (oldVal !== newVal) {
                this.status = newVal === 'active';
            }
        }
    },
}
</script>

<style>

</style>